;===========================================================================
;Koopa Troopa's Totally Sweet Basic States File
;----------------------------------------
;Vars used:
; 0 - Determines if the Koopa PANCH has been comboed into.
; 1 - Holds time during multi-hit version of Shell Spin
; 3 - random velocity, horizontal, on coins in SKS
; 4 - random velocity, vertical, on coins in SKS
; 5 - Shun Koopa Satsu finish
; 6 - random winpose/intro selector
; 7 - checks if KT has slid into shell
; 58 - used in a helper state to store if a coin has hit or not.
; 59 - used in a helper state to store random horiz vel without
;       changing it every tick, as my old code did.
;===========================================================================
;---------------------------------------------------------------------------
; Aww, mang! I am lose!
[Statedef 170]
type = S
ctrl = 0
anim = 170
velset = 0,0

[State 180, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 5, 5
channel = 0

[State 170, 1]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

;---------------------------------------------------------------------------
; How shall I taunt you?
[Statedef 180]
type = S

[State 180, SKS Finish]
type = ChangeState
trigger1 = Var(5) = 1
value = 182

[State 180, Varrandom]
type = VarRandom
trigger1 = Time = 0
v = 6
range = 1,2

[State 180, 1]
type = ChangeState
trigger1 = Var(6) = 1
value = 181

[State 180, 2]
type = ChangeState
trigger1 = Var(6) = 2
value = 183

;---------------------------------------------------------------------------
; Win Pose 1 - Dan would be so proud...
[Statedef 181]
type = S
ctrl = 0
anim = 181
velset = 0,0

[State 181, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 4, 0
channel = 0

[State 181, 1]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

;---------------------------------------------------------------------------
; Win Pose 2 - MUSHROOM.
[Statedef 182]
type = S
ctrl = 0
anim = 3203
velset = 0,0

[State 3203, Varset]
type = VarSet
trigger1 = Time = 0
v = 5
value = 0

[State 181, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 5, 7
channel = 0

[State 182, 1]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

;---------------------------------------------------------------------------
; Win Pose 3 - Double V!
[Statedef 183]
type = S
ctrl = 0
anim = 183
velset = 0,0

[State 183, PlaySnd]
type = PlaySnd
trigger1 = Time = 2
value = 5, 1
channel = 0

[State 183, 1]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1

;---------------------------------------------------------------------------
; Intro Select
[Statedef 190]
type = S
ctrl = 0
anim = 190
velset = 0,0

[State 191, Varrandom]
type = VarRandom
trigger1 = Time = 0
v = 6
range = 1,2

[State 191, 1]
type = ChangeState
trigger1 = Var(6) = 1
value = 191

[State 191, 2]
type = ChangeState
trigger1 = Var(6) = 2
value = 193

;---------------------------------------------------------------------------
; Fly-in Intro, part 1
[Statedef 191]
type = S
ctrl = 0
anim = 190
velset = 0,0

[State 191, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 1,0

[State 191, PosSet]
type = PosSet
trigger1 = RoundState = 0
y = -300

[State 191, 1] ;Freeze animation until PreIntro is over
type = ChangeAnim
trigger1 = RoundState = 0
value = 190

[State 191, 2] ;Assert this until you want "round 1, fight" to begin
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 191, Velset]
type = VelSet
trigger1 = 1
y = 3.5

[State 190, 3]
type = ChangeState
trigger1 = Vel Y > 0
trigger1 = Pos Y >= 0
value = 192

; Fly-in Intro, part 2
[Statedef 192]
type = S
ctrl = 0
anim = 192
velset = 0,0

[State 191, PlaySnd]
type = PlaySnd
trigger1 = Time = 2
value = 5, 2
channel = 0

[State 191, PosSet]
type = PosSet
trigger1 = Time = 0
y = 0

[State 191, 2] ;Assert this until you want "round 1, fight" to begin
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 191, 3]
type = ChangeState
trigger1 = Animtime = 0
value = 0

;---------------------------------------------------------------------------
; Slide-in Intro, part 1
[Statedef 193]
type = S
ctrl = 0
anim = 193
velset = 0,0

[State 193, Varset]
type = VarSet
trigger1 = Time = 1
v = 7
value = 0

[State 193, Helper]
type = Helper
trigger1 = Time = 1
helpertype = normal
name = "Sliding KT"
ID = 1931
pos = -150,0
postype = p1
facing = 1
stateno = 1931
ownpal = 1
size.xscale = 1
size.yscale = 1

[State 193, 2] ;Assert this until you want "round 1, fight" to begin
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 193, 1] ;Freeze animation until PreIntro is over
type = ChangeAnim
trigger1 = RoundState = 0
value = 193

[State 193, 1]
type = ChangeAnim
trigger1 = Var(7) = 1
value = 194

[State 193, 3]
type = ChangeState
trigger1 = Var(7) = 1
value = 194

; Slide-in Intro (sliding KT)
[Statedef 1931]
type    = S
physics = S
anim = 1931

[State 1931, 0]
type = VelSet
trigger1 = Time > 0
x = 4

[State 1931, 1]
type = ParentVarSet
trigger1 = Pos X >= parent, Pos X
v = 7
value = 1

[State 1931, 2]
type = DestroySelf
trigger1 = Pos X >= parent, Pos X

; Slide-in Intro, part 2
[Statedef 194]
type = S
ctrl = 0
anim = 194
velset = 0,0

[State 194, PlaySnd]
type = PlaySnd
trigger1 = Time = 15
value = 5, 2
channel = 0

[State 194, PosSet]
type = PosSet
trigger1 = Time = 0
y = 0

[State 194, 2] ;Assert this until you want "round 1, fight" to begin
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 194, 3]
type = ChangeState
trigger1 = Animtime = 0
value = 0

;---------------------------------------------------------------------------
; Taunt.
[Statedef 195]
type = S
ctrl = 0
anim = 195
velset = 0,0
movetype = I
physics = S
sprpriority = 2
poweradd = 50

[State 195, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 1, 0
channel = 0

[State 195, Changestate]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Basic Attacks
;---------------------------------------------------------------------------
; Standing Light Punch
[Statedef 200]
type = S
movetype = A
physics = S
juggle = 1
velset = 0,0
anim = 200
poweradd = 25
ctrl = 0

[State 200, PlaySnd]
type = PlaySnd
trigger1 = Time = 2
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 200, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 0

[State 200, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = S, NA
hitflag = MAF
guardflag = MA
animtype = Light
priority = 3,Hit
damage = 34,0
pausetime = 10,10
sparkno = 1
sparkxy = 10,-45
hitsound = s12, 0
guardsound = s14, 0
ground.type = High
air.type = High
ground.slidetime = 9
ground.hittime = 12
ground.velocity = -4
air.velocity = -3,-3

[State 200, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Standing Medium Punch
[Statedef 210]
type = S
movetype = A
physics = S
juggle = 2
velset = 0,0
anim = 210
poweradd = 50
ctrl = 0

[State 210, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 210, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 2

[State 210, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = S, NA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 58,0
pausetime = 10,10
sparkno = 1
sparkxy = 10,-45
hitsound = s12, 1
guardsound = s14, 1
ground.type = High
air.type = High
ground.slidetime = 12
ground.hittime = 14
ground.velocity = -5.5
air.velocity = -3,-4
;airguard.velocity = -2,-.8

[State 210, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Standing Strong Punch
[Statedef 220]
type = S
movetype = A
physics = S
juggle = 2
velset = 0,0
anim = 220
poweradd = 72
ctrl = 0

[State 220, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 220, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 220, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = S, NA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 76,0
pausetime = 13,12
sparkno = 2
sparkxy = 10,-45
hitsound = s13, 0
guardsound = s14, 2
ground.type = High
air.type = High
ground.slidetime = 14
ground.hittime = 17
ground.velocity = -8.4
air.velocity = -3,-5
;airguard.velocity = -2,-.8

[State 220, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Standing Light Kick
[Statedef 230]
type = S
movetype = A
physics = S
juggle = 1
velset = 0,0
anim = 230
poweradd = 30
ctrl = 0

[State 230, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 230, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 1

[State 230, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = S, NA
hitflag = MAF
guardflag = MA
animtype = Light
priority = 3,Hit
damage = 37,0
pausetime = 8,8
sparkno = 1
sparkxy = 10,-25
hitsound = s12, 0
guardsound = s14, 0
ground.type = Low
air.type = Low
ground.slidetime = 9
ground.hittime = 11
ground.velocity = -3.5
air.velocity = -3,-3
;airguard.velocity = -2,-.8

[State 230, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Standing Medium Kick
[Statedef 240]
type = S
movetype = A
physics = S
juggle = 3
velset = 0,0
anim = 240
poweradd = 52
ctrl = 0

[State 240, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 240, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 3

[State 240, Hitdef]
type = HitDef
trigger1 = Animelem = 4
attr = S, NA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 59,0
pausetime = 10,10
sparkno = 1
sparkxy = 10,-25
hitsound = s12, 1
guardsound = s14, 1
ground.type = High
air.type = High
ground.slidetime = 13
ground.hittime = 15
ground.velocity = -5
air.velocity = -3,-3
;airguard.velocity = -2,-.8

[State 240, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Standing Strong Kick
[Statedef 250]
type = S
movetype = A
physics = S
juggle = 4
velset = 0,0
anim = 250
poweradd = 75
ctrl = 0

[State 250, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 250, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 250, Hitdef]
type = HitDef
trigger1 = Animelem = 4
attr = S, NA
hitflag = MA
guardflag = MA
animtype = Hard ;Diagup
priority = 4,Hit
damage = 74,0
pausetime = 12,11
sparkno = 2
sparkxy = 10,-35
hitsound = s13, 0
guardsound = s14, 2
ground.type = High
air.type = High
ground.slidetime = 16
ground.hittime = 19
ground.velocity = -9 ;-1,-8
air.velocity = -2,-5

[State 250, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Light Punch
[Statedef 400]
type = C
movetype = A
physics = C
juggle = 1
velset = 0,0
anim = 400
poweradd = 25
ctrl = 0

[State 400, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 400, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 0

[State 400, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = C, NA
hitflag = MAF
guardflag = M
animtype = Light
priority = 3,Hit
damage = 38,0
pausetime = 10,10
sparkno = 1
sparkxy = 10,-35
hitsound = s12, 0
guardsound = s14, 0
ground.type = Low
air.type = Low
ground.slidetime = 9
ground.hittime = 14
ground.velocity = -4
air.velocity = -2,-3
;airguard.velocity = -2,-.8

[State 400, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Medium Punch
[Statedef 410]
type = C
movetype = A
physics = C
juggle = 2
velset = 0,0
anim = 410
poweradd = 48
ctrl = 0

[State 410, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 410, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 2

[State 410, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = C, NA
hitflag = MAF
guardflag = M
animtype = Medium
priority = 3,Hit
damage = 51,0
pausetime = 11,11
sparkno = 1
sparkxy = 10,-35
hitsound = s12, 1
guardsound = s14, 1
ground.type = Low
air.type = Low
ground.slidetime = 11
ground.hittime = 15
ground.velocity = -4.5
air.velocity = -2,-3
;airguard.velocity = -2,-.8

[State 410, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Strong Punch
[Statedef 420]
type = C
movetype = A
physics = C
juggle = 2
velset = 0,0
anim = 420
poweradd = 67
ctrl = 0

[State 420, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 420, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 420, Velset]
type = Velset
trigger1 = Animelem = 2,1
x = 10

[State 420, Hitdef]
type = HitDef
trigger1 = Animelem = 2
attr = C, NA
hitflag = MAF
guardflag = L
animtype = Hard
priority = 3,Hit
damage = 74,0
pausetime = 8,11
sparkno = 2
sparkxy = 10,-15
hitsound = s13, 0
guardsound = s14, 2
ground.type = Low
air.type = Low
ground.slidetime = 16
ground.hittime = 18
ground.velocity = -10
air.velocity = -6,-2
;airguard.velocity = -2,-.8

[State 420, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Light Kick
[Statedef 430]
type = C
movetype = A
physics = C
juggle = 1
velset = 0,0
anim = 430
poweradd = 25
ctrl = 0

[State 430, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 1

[State 430, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 430, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = C, NA
hitflag = MAF
guardflag = L
animtype = Light
priority = 3,Hit
damage = 35,0
pausetime = 9,8
sparkno = 1
sparkxy = 10,-15
hitsound = s12, 0
guardsound = s14, 0
ground.type = Low
air.type = Low
ground.slidetime = 12
ground.hittime = 14
ground.velocity = -3.5
air.velocity = -2,-3
;airguard.velocity = -2,-.8

[State 430, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Medium Kick
[Statedef 440]
type = C
movetype = A
physics = C
juggle = 2
velset = 0,0
anim = 440
poweradd = 49
ctrl = 0

[State 440, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 440, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 3

[State 440, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = C, NA
hitflag = MAF
guardflag = L
animtype = Medium
priority = 3,Hit
damage = 67,0
pausetime = 10,9
sparkno = 1
sparkxy = 10,-15
hitsound = s12, 1
guardsound = s14, 1
ground.type = Low
air.type = Low
ground.slidetime = 13
ground.hittime = 16
ground.velocity = -4.5
air.velocity = -2,-3
;airguard.velocity = -2,-.8

[State 440, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Crouching Strong Kick
[Statedef 450]
type = C
movetype = A
physics = C
juggle = 2
velset = 0,0
anim = 450
poweradd = 76
ctrl = 0

[State 450, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 450, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 450, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = C, NA
hitflag = MAF
guardflag = L
animtype = Hard
priority = 4,Hit
damage = 75,0
pausetime = 12,12
sparkno = 1
sparkxy = 10,-15
hitsound = s13, 0
guardsound = s14, 2
ground.type = Trip
air.type = Low
ground.slidetime = 19
ground.hittime = 20
ground.velocity = -1.4,-3
air.velocity = -2,-3
;airguard.velocity = -2,-.8
fall = 1

[State 450, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Jumping Light Punch
[Statedef 600]
type = A
movetype = A
physics = A
juggle = 2
anim = 600
poweradd = 25
ctrl = 0

[State 600, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 0

[State 600, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 600, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Light
priority = 3,Hit
damage = 27,0
pausetime = 7,7
sparkno = 1
sparkxy = 10,-45
hitsound = s12, 0
guardsound = s14, 0
ground.type = High
air.type = High
ground.slidetime = 5
ground.hittime = 7
ground.velocity = -3
air.velocity = -1.5,-3

;---------------------------------------------------------------------------
; Jumping Medium Punch
[Statedef 610]
type = A
movetype = A
physics = A
juggle = 3
anim = 610
poweradd = 35
ctrl = 0

[State 610, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 610, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 2

[State 610, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Medium
priority = 4,Hit
damage = 52,0
pausetime = 9,9
sparkno = 1
sparkxy = 10,-45
hitsound = s12, 1
guardsound = s14, 1
ground.type = High
air.type = High
ground.slidetime = 7
ground.hittime = 9
ground.velocity = -5
air.velocity = -2.5,-3

;---------------------------------------------------------------------------
; Jumping Strong Punch
[Statedef 620]
type = A
movetype = A
physics = A
juggle = 4
anim = 620
poweradd = 50
ctrl = 0

[State 620, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 620, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 620, Hitdef]
type = HitDef
trigger1 = Animelem = 3
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Hard
priority = 4,Hit
damage = 79,0
pausetime = 11,9
sparkno = 1
sparkxy = 10,-45
hitsound = s13, 0
guardsound = s14, 2
ground.type = High
air.type = High
ground.slidetime = 9
ground.hittime = 12
ground.velocity = -7
air.velocity = -4,-1

;---------------------------------------------------------------------------
; Jumping Light Kick
[Statedef 630]
type = A
movetype = A
physics = A
juggle = 3
anim = 630
poweradd = 30
ctrl = 0

[State 630, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 1

[State 630, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 0
channel = 0

[State 630, Hitdef]
type = HitDef
trigger1 = Animelem = 2
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Light
priority = 3,Hit
damage = 25,0
pausetime = 7,7
sparkno = 1
sparkxy = 10,-25
hitsound = s12, 0
guardsound = s14, 0
ground.type = High
air.type = High
ground.slidetime = 6
ground.hittime = 6
ground.velocity = -3.5
air.velocity = -2,-3

;---------------------------------------------------------------------------
; Jumping Medium Kick
[Statedef 640]
type = A
movetype = A
physics = A
juggle = 3
anim = 640
poweradd = 40
ctrl = 0

[State 640, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 1
channel = 0

[State 640, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 3

[State 640, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Medium
priority = 4,Hit
damage = 58,0
pausetime = 9,9
sparkno = 1
sparkxy = 10,-25
hitsound = s12, 1
guardsound = s14, 1
ground.type = High
air.type = High
ground.slidetime = 7
ground.hittime = 9
ground.velocity = -5
air.velocity = -3,3

;---------------------------------------------------------------------------
; Jumping Strong Kick
[Statedef 650]
type = A
movetype = A
physics = A
juggle = 4
anim = 650
poweradd = 50
ctrl = 0

[State 650, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
trigger1 = (random <= 500)
value = 2, 2
channel = 0

[State 650, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 10, 4

[State 650, Hitdef]
type = HitDef
trigger1 = Animelem = 4
attr = A, NA
hitflag = HA
guardflag = HA
animtype = Hard
priority = 4,Hit
damage = 75,0
pausetime = 11,9
sparkno = 1
sparkxy = 10,-45
hitsound = s13, 0
guardsound = s14, 2
ground.type = High
air.type = High
ground.slidetime = 10
ground.hittime = 14
ground.velocity = -7
air.velocity = -4,-3

;---------------------------------------------------------------------------
; Damn Throw (start, based heavily on KFM's throw, because I am
;            fucking lazy.)
[Statedef 300]
type    = S
movetype= A
physics = S
juggle  = 0
velset = 0,0
ctrl = 0
anim = 300
sprpriority = 2

[State 300, Hitdef]
type = HitDef
Trigger1 = Time = 0
attr = S, NT
hitflag = M-
priority = 1, Miss
sparkno = -1
sprpriority = 1
hitsound = s10, 5
p1facing = ifelse (command = "holdfwd", -1, 1) 
p2facing = 1
p1stateno = 310
p2stateno = 320
guard.dist = 0
fall = 1

[State 300, END!]
type = ChangeState
Trigger1 = AnimTime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Damn Throw (throwing)
[Statedef 310]
type    = S
movetype= A
physics = N
anim = 310
poweradd = 60

[State 310, TB 1]
type = TargetBind
trigger1 = Animelem = 1
time = 1
ID = -1
pos = 10,0

[State 310, TB 2]
type = TargetBind
trigger1 = Animelem = 2
time = 1
ID = -1
pos = 8, -10

[State 310, TB 3]
type = TargetBind
trigger1 = Animelem = 3
time = 1
ID = -1
pos = 0, -14

[State 310, TB 4]
type = TargetBind
trigger1 = Animelem = 4
time = 1
ID = -1
pos = -5, -24

[State 310, TB 5]
type = TargetBind
trigger1 = Animelem = 5
time = 1
ID = -1
pos = -20, -28

[State 310, I am totally crushing CHILDREN!]
type = TargetLifeAdd
trigger1 = AnimElem = 5
value = -103

[State 310, PLAYSND!!!!]
type = PlaySnd
trigger1 = AnimElem = 5
value = 10, 4

[State 310, Change Teh State]
type = TargetState
trigger1 = AnimElem = 5
value = 321

[State 310, State End]
type = ChangeState
trigger1 = AnimTime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Thrown by Damn Throw
[Statedef 320]
type    = A
movetype= H
physics = N
velset = 0,0

[State 820, 1]
type = ChangeAnim2
Trigger1 = Time = 0
value = 320

;---------------------------------------------------------------------------
;Thrown by Damn Throw into Air
[Statedef 321]
type    = A
movetype= H
physics = N
velset = 4,-7
poweradd = 40

[State 321, 1]
type = VelAdd
Trigger1 = 1
y = .4

[State 321, 2]
type = ChangeState
triggerall = Vel Y > 0
triggerall = Pos Y >= -20
triggerall = alive
triggerall = CanRecover
trigger1 = Command = "recovery"
value = 5200 ;HITFALL_RECOVER

[State 321, 3]
type = SelfState
triggerall = Vel Y > 0
triggerall = alive
triggerall = CanRecover
trigger1 = Command = "recovery"
value = 5210

[State 321, 4]
type = SelfState
trigger1 = Vel Y > 0
trigger1 = Pos Y >= 0
value = 5100

;---------------------------------------------------------------------------
; Override common states (use same number to override) :
;---------------------------------------------------------------------------
; Stand
[Statedef 0]
type = S
physics = S
sprpriority = 0

[State 0, 1]
type = ChangeAnim
trigger1 = Anim != 0 && Anim != 5 && Var(5) = 0
trigger2 = Anim = 5 && AnimTime = 0 && Var(5) = 0 ;Turn anim over
value = 0

[State 0, 1]
type = ChangeAnim
trigger1 = Var(5) = 1 ;finished with SKS
value = 3203

[State 0, 2]
type = VelSet
trigger1 = Time = 0
y = 0

[State 0, 3] ;Stop moving if low velocity or 4 ticks pass
type = VelSet
trigger1 = abs(vel x) < 2
trigger2 = Time = 4
x = 0

[State 0, 4] ;Are you dead?
type = ChangeState
trigger1 = !alive
value = 5050

;---------------------------------------------------------------------------
; Hop Forward, mangs!
[Statedef 100]
type    = A
physics = A
ctrl = 0
anim = 100
sprpriority = 1

[State 100, 1]
type = VelSet
trigger1 = Time = 0
x = const(velocity.run.fwd.x)
y = const(velocity.run.fwd.y)

[State 100, 2]
type = CtrlSet
trigger1 = Time = 2
value = 1

[State 100, 3]
type = ChangeState
trigger1 = Vel Y > 0
trigger1 = Pos Y >= 0
value = 106

;---------------------------------------------------------------------------
; Hop Backward, mangs!
[Statedef 105]
type    = A
physics = A
ctrl = 0
anim = 105
sprpriority = 1

[State 105, 1]
type = VelSet
trigger1 = Time = 0
x = const(velocity.run.back.x)
y = const(velocity.run.back.y)

[State 105, 2]
type = CtrlSet
trigger1 = Time = 2
value = 1

[State 105, 3]
type = ChangeState
trigger1 = Vel Y > 0
trigger1 = Pos Y >= 0
value = 106

;---------------------------------------------------------------------------
; Hop Landing!
[Statedef 106]
type    = S
physics = S
ctrl = 0
anim = 47

[State 106, 1]
type = VelSet
trigger1 = Time = 0
y = 0

[State 106, 2]
type = PosSet
trigger1 = Time = 0
y = 0

[State 106, 3]
type = MakeDust
trigger1 = Time = 2
pos = -5,-2
spacing = 1

[State 106, 4]
type = ChangeState
trigger1 = Time = 7
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Jump Up
[Statedef 50]
type    = A
physics = A

[State 50, 1]
type = VarSet
trigger1 = Time = 0
sysvar(1) = 0

[State 50, 2]
type = ChangeAnim
trigger1 = Time = 0
value = ifelse((vel x)=0, 41, ifelse((vel x)>0, 42, 43))

[State 50, 3]
type = ChangeAnim
trigger1 = Vel y > -2
trigger1 = SelfAnimExist(anim + 3)
persistent = 0
value = Anim + 3

[State 50, Airjump Crap]
type = ChangeAnim
trigger1 = PrevStateNo = 45
value = 800
persistent = 0

;---------------------------------------------------------------------------
; States that are always executed (use statedef -2)
;---------------------------------------------------------------------------
[Statedef -2]

[State -2, Ow Sound] ;Based on Storm's, as always.
type = PlaySnd
triggerall = Time = 1
triggerall = alive && (random <= 500)
trigger1 = stateno = 5001 || stateno = 5011
trigger2 = stateno = 5040 || stateno = 5050
trigger3 = stateno = 5070
value = 5000,0+(GetHitVar(animtype))

[State -2, Recover Sound]
type = PlaySnd
triggerall = Time = 1
triggerall = alive
trigger1 = stateno = 5200 || stateno = 5210
value = 4,9

[State -2, Hot Clipboard Action]
type = DisplayToClipboard
trigger1 = 1
text = "Time Counter: %d"
params = var(1)

;---------------------------------------------------------------------------
; States that are executed when in self's state file (use statedef -3)
;---------------------------------------------------------------------------
;[Statedef -3]
