;===========================================================================
; Koopa Troopa's Hyper Moves
;----------------------------------------
;Vars used:
; 0 - Determines if the Koopa PANCH has been comboed into.
; 1 - Holds time during multi-hit version of Shell Spin
; 3 - random velocity, horizontal, on coins in SKS
; 4 - random velocity, vertical, on coins in SKS
; 5 - Shun Koopa Satsu finish
; 6 - random winpose selector
; 7 - checks if KT has slid into shell
; 58 - used in a helper state to store if a coin has hit or not.
; 59 - used in a helper state to store random horiz vel without
;       changing it every tick, as my old code did.
;===========================================================================
;---------------------------------------------------------------------------
; Super Flash Kick - First Kick
[Statedef 3000]
type    = S
movetype= A
physics = S
juggle  = 8
velset = 0,0
anim = 1000
ctrl = 0
sprpriority = 2

[State 3000, Startup Invincibility]
type = NotHitBy
trigger1 = Time = 0
value = SCA
time = 6

[State 3000, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, HA
animtype  = Medium
damage    = 85, 20
priority  = 5
guardflag = MA
pausetime = 2,9
sparkxy = -10,-70
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 18
ground.hittime  = 18
ground.velocity = -3.5,-7
guard.velocity = -7
air.velocity = -3.5,-7
air.recover = 0
fall = 1
kill = 0

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 1 
value = 4, 1
channel = 0

[State 3000, SuperPause]
type = SuperPause
trigger1 = Time = 1
trigger1 = PrevStateNo != 4002
time = 30
anim = 100
sound = 20, 0
pos = 20,-30
poweradd = -1000

[State 3000, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 3001

;------------------
; Super Flash Kick - First Kick Jump
[Statedef 3001]
type    = A
movetype= A
physics = A ;N
velset = 3,-6
anim = 1001

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 2
channel = 0

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Animelem = 2 
value = 16, 0

[State 3001, Kaboom!]
type = Explod
trigger1 = Animelem = 2
anim = 1205
ID = 3001 
pos = 28,-42
postype = p1
facing = 1
bindtime = 1
vel = 0,0
removetime = -2
scale = 1, 1
ontop = 1
ownpal = 1
removeongethit = 0

[State 3001, Hitdef]
type = HitDef
trigger1 = AnimElem = 2
attr = A, HA
animtype  = Medium
damage    = 90, 25
priority  = 5
guardflag = MA
pausetime = 2,9
sparkxy = -10,-50
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 18
ground.hittime  = 18
ground.velocity = -3.5,-7
guard.velocity = -7
air.velocity = -3.5,-7
air.recover = 0
fall = 1
; stolen from Sander! :D
Palfx.time = 60       
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 3001, Explod]
type = Explod
trigger1 = Animelem = 2 
anim = 1005 
ID = 3005
pos = 0,0
postype = p1
facing = 1
bindtime = 9
removetime = -2
ontop = 1
ownpal = 1
removeongethit = 1

[State 3001, Veladd]
type = VelAdd
trigger1 = Vel X > 1
x = -.45

[State 3001, Changestate]
type = Changestate
trigger1 = AnimElem = 4
value = 3010

; Super Flash Kick - Second Kick
[Statedef 3010]
type    = A
movetype= A
physics = A
velset = 3,0
anim = 1000
ctrl = 0
velset = 0,0
sprpriority = 2

[State 3010, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, HA
animtype  = Medium
damage    = 75, 20
priority  = 5
guardflag = MA
pausetime = 2,6
sparkxy = -10,-70
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 22
ground.hittime  = 22
ground.velocity = -2.5,-7.4
guard.velocity = -7
air.velocity = -3.5,-7.4
air.recover = 0
fall = 1

[State 3010, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 3011

;------------------
; Super Flash Kick - Second Kick Jump
[Statedef 3011]
type    = A
movetype= A
physics = A ;N
velset = 5,-9
anim = 1001

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 3
channel = 0

[State 3011, PlaySnd]
type = PlaySnd
trigger1 = Animelem = 2 
value = 16, 0

[State 3011, KA-BLOOIE!]
type = Explod
trigger1 = Animelem = 2 
anim = 3405
ID = 3010
pos = 28,-42
postype = p1
facing = 1
bindtime = 1
vel = 0,0
removetime = -2
scale = 1, 1
ontop = 1
ownpal = 1
removeongethit = 0

[State 3011, Hitdef 2]
type = HitDef
trigger1 = Animelem = 2
attr = A, HA
animtype  = Medium
damage    = 85, 25
priority  = 5
guardflag = MA
pausetime = 2,6
sparkxy = -10,-50
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 22
ground.hittime  = 22
ground.velocity = -2.5,-9
guard.velocity = -7
air.velocity = -3.5,-7.4
air.recover = 0
fall = 1
; stolen from Sander! :D
Palfx.time = 60         
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 3011, Hitdef 3]
type = HitDef
trigger1 = Animelem = 3
attr = A, HA
animtype  = Medium
damage    = 75, 17
priority  = 5
guardflag = MA
pausetime = 2,6
sparkxy = -10,-50
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 22
ground.hittime  = 22
ground.velocity = -2.5,-9
guard.velocity = -7
air.velocity = -3.5,-7.4
air.recover = 0
fall = 1
; stolen from Sander! :D
Palfx.time = 60        
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 3011, Explod]
type = Explod
trigger1 = Animelem = 2 
anim = 1005 
ID = 1025
pos = 0,0
postype = p1
facing = 1
bindtime = 9
removetime = -2
ontop = 1
ownpal = 1
removeongethit = 1

[State 3011, Veladd]
type = VelAdd
trigger1 = Vel X > 1
x = -.45

[State 3011, CtrlSet]
type = CtrlSet
trigger1 = Animtime > 20
value = 1

;===========================================================================
;---------------------------------------------------------------------------
; Shun Koopa Satsu
; -- Parts of this code taken from or based upon Sunboy's Gouki.
[Statedef 3200]
type    = S
movetype= A
physics = S
velset = 0,0
anim = 3200
ctrl = 0
sprpriority = 2

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 4, 2
channel = 0

[State 3200, Velset]
type = VelSet
trigger1 = Time > 10
x = 4

;[State 3200, PowerAdd]
;type = PowerAdd
;trigger1 = Time = 1
;value = -3000

[State 3000, SuperPause]
type = SuperPause
trigger1 = Time = 1
time = 30
anim = 102
sound = 20, 0
pos = 7,-35
poweradd = -3000

[State 3200, Oh Snap!]
type = HitDef
Trigger1 = Time = 0
attr = S, HT
hitflag = M-
priority = 7, Dodge
hitsound = s12, 0
sparkno = -1
sprpriority = 1
p1facing = 1
p2facing = 1
p1stateno = 3201
p2stateno = 3210
guard.dist = 0
fall = 1

[State 3200, You Fail It!]
type = ChangeState
trigger1 = Time > 50
value = 0
ctrl = 1

; Shun Koopa Satsu (Grabbing)
[Statedef 3201]
type    = S
movetype= A
physics = N
velset = 0,0
anim = 3201
ctrl = 0
sprpriority = 1

[State 3201, Grab That Bitch]
type = TargetBind
trigger1 = 1
time = 1
ID = -1
pos = 10,0

[State 3201, MOVE ALONG NOTHING TO SEE HERE]
type = ChangeState
trigger1 = Time > 15
value = 3202

; Shun Koopa Satsu (Beating Shit Out of)
[Statedef 3202]
type    = S
movetype= A
physics = N
velset = 0,0
anim = 3202
ctrl = 0
sprpriority = 1

[State 3202, Grab That Bitch]
type = TargetBind
trigger1 = 1
time = 1
ID = -1
pos = 10,0

[State 3202, BLOCK OUT THE SUN]
type = AssertSpecial
trigger1 = 1
flag = NoBarDisplay
flag2 = NoFG
flag3 = NoBG

[State 3202, OH SHIT BLACK]
type = PalFX
trigger1 = 1
time = 1
add = -255,-255,-255

[State 3202, PlayerPush]
type = PlayerPush
trigger1 = 1
value = 0

[State 3202, Explod]
type = Explod
trigger1 = Time % 4
anim = F3
ontop = 1
postype = p1
pos = 0,-60
facing = IfElse(Random < 500,-1,1)
random = 60,120
bindtime = 1
ownpal = 1

; Shamelessly stolen from my own Ryouga
[State 3202, VarRandom] ; Set random horiz vel
type = VarRandom
trigger1 = 1
v = 3
range = -3, 3

[State 3202, VarRandom 2] ; Set random vert vel
type = VarRandom
trigger1 = 1
v = 4
range = -14, -6

[State 3202, Coin Sound]
type = PlaySnd
trigger1 = Time % 4
value = 1, 0
volume = 0

[State 3202, Spawn Coin]
type = Helper
trigger1 = Time % 4
helpertype = normal
name = "Coin"
ID = 3205
pos = 0,-60
postype = p1
facing = 1
stateno = 3205
ownpal = 1
size.xscale = 1
size.yscale = 1
; End Shamless Theft

[State 3202, PlaySnd]
type = PlaySnd
trigger1 = Time % 4
value = s13,1

[State 3202, TargetBind]
type = TargetBind
trigger1 = Time = 64
time = 1
pos = 1,0

[State 3202, TargetLifeAdd]
type = TargetLifeAdd
trigger1 = Time = 68
value = -777

[State 3202, NoKOSlow]
type = AssertSpecial
trigger1 = 1
flag = nokoslow

[State 3202, ChangeState]
type = ChangeState
trigger1 = Time = 68
value = 3203

; Shun Koopa Satsu (Finish)
[Statedef 3203]
type    = S
movetype= A
physics = N
velset = 0,0
anim = 3203
ctrl = 0
sprpriority = -2

[State 3202, NoKOSlow]
type = AssertSpecial
trigger1 = 1
flag = nokoslow

[State 3203, PlayerPush]
type = PlayerPush
trigger1 = 1
value = 0

[State 3203, Stuff]
type = Helper
trigger1 = Win
helpertype = normal
name = "Black Screen"
ID = 3221
pos = 0,0
postype = p1
stateno = 3221
ownpal = 0

[State 3203, Varset]
type = VarSet
trigger1 = Win
v = 5
value = 1

[State 3203, ChangeState]
type = ChangeState
trigger1 = Time >= 70 && Roundstate = 2
value = 0
ctrl = 1

[State 3203, ChangeState]
type = ChangeState
trigger1 = Time >= 140
value = 0
ctrl = 1

; Special Effects for SKS Finish
[Statedef 3221]
type    = S
movetype= I
physics = N
anim = 9999

[State 3221, BLOCK OUT THE SUN]
type = AssertSpecial
trigger1 = Win
flag = NoBarDisplay
flag2 = NoFG
flag3 = NoBG

[State 3221, MUSHROOM]
type = Explod
trigger1 = Win
anim = 3220
ID = 3220
sprpriority = -3
postype = left
pos = 0,0
bindtime = -1
removetime = -1

;[State 3221, SUICIDE]
;type = DestroySelf
;trigger1 = 

; Shun Koopa Satsu (Coin)
; Also taken from my Ryouga.
[Statedef 3205]
type = S
physics = S
movetype = A
anim = 3205
ctrl = 0
sprpriority = 2

[State 3205, VarSet]
type = VarSet
trigger1 = Time = 1
v = 58
value = 0

[State 3205, Varset 2]
type = Varset
trigger1 = Time = 0
v = 59
value = parent, var(3)

[State 3205, Velset]
type = Velset
trigger1 = Time > 0 && var(58) = 0
x = var(59)

[State 3205, Velset 2]
type = Velset
trigger1 = Time = 0 && var(58) = 0
y = parent, var(4)

[State 3205, Gravity]
type = Gravity
trigger1 = Time > 0

[State 3205, VarSet 3]
type = VarSet
trigger1 = Pos Y > 0 || Movecontact
v = 58
value = 1

[State 3205, ChangeAnim]
type = ChangeAnim
trigger1 = var(58) = 1
value = 3206
persistent = 0

[State 3205, Velset 3]
type = VelSet
trigger1 = var(58) = 1 && animelem = 1
y = -6

[State 3205, Velset 4]
type = VelSet
trigger1 = var(58) = 1
x = var(59) / 2

[State 3205, DestroySelf]
type = DestroySelf
trigger1 = var(58) = 1 && Animelem >= 8

; Shun Koopa Satsu (Getting Hit By, Part 1)
[Statedef 3210]
type = S
movetype = H
physics = N
sprpriority = 0
velset = 0,0
ctrl = 0

[State 3210, ChangeAnim2]
type = ChangeAnim2
trigger1 = Time = 0
value = 3210

[State 3210, PalFX]
type = PalFX
trigger1 = Time > 15
time = 1
add = -255,-255,-255

[State 3210, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 0,0

[State 3210, ChangeState]
type = ChangeState
trigger1 = Time = 17
value = 3211

; Shun Koopa Satsu (Gethit Part 2)
[Statedef 3211]
type = L
movetype = H
physics = N
anim = 5110
ctrl = 0

[State 3211, PlayerPush]
type = PlayerPush
trigger1 = 1
value = 0

[State 3211, PalFX]
type = PalFX
trigger1 = 1
time = 1
add = -255,-255,-255

[State 3211, ChangeState]
type = ChangeState
trigger1 = Time = 68
value = 3212

; Shun Koopa Satsu (Gethit Part 3)
[Statedef 3212]
type = L
movetype = H
physics = N
anim = 5110
ctrl = 0

[State 3212, PlayerPush]
type = PlayerPush
trigger1 = 1
value = 0

[State 3212, ChangeAnim]
type = ChangeAnim
trigger1 = SelfAnimExist(5150) && !Alive && Anim != 5150
value = 5150

[State 3212, SelfState]
type = SelfState
trigger1 = !Alive
value = 5150

[State 3212, SelfState]
type = SelfState
trigger1 = Time = (70 + const(data.liedown.time))
value = 5120

;===========================================================================
;---------------------------------------------------------------------------
; HUZZAH! (startup)
[Statedef 4000]
type    = S
movetype= A
physics = S
juggle  = 3
velset = 0,0
anim = 4000
ctrl = 0
sprpriority = 2

[State 4001, PlaySnd]
type = PlaySnd
trigger1 = Time = 1 
value = 4, 3
channel = 0

[State 4000, SuperPause]
type = SuperPause
trigger1 = Time = 1
time = 30
anim = 100
sound = 20, 0
pos = 20,-30
poweradd = -1000

[State 4000, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 4001

;------------------
; HUZZAH! (flying)
[Statedef 4001]
type    = A
movetype= A
physics = A ;N
velset = 9,-3
anim = 4001

[State 4001, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, HA
animtype  = Medium
damage    = 30, 5
priority  = 6
guardflag = MA
pausetime = 2,9
sparkxy = -10,-50
getpower = 0
hitsound = s13, 0
guardsound = s14, 2
ground.type = High
ground.slidetime = 18
ground.hittime  = 18
ground.velocity = -3.5,-7
guard.velocity = -7
air.velocity = -3.5,-7
air.recover = 0
kill = 0
p1stateno = 4002
p2stateno = 4010

;---------------------------------------------------------------------------
; HUZZAH! (beatdown)
[Statedef 4002]
type    = S
movetype= A
physics = S
velset = 0,0
anim = 4002
ctrl = 0
sprpriority = 2

[State 4001, PlaySnd]
type = PlaySnd
trigger1 = Time = 1 
value = 4, 7
channel = 0

[State 4002, NotHitBy]
type = NotHitBy
trigger1 = 1
value = SCA

[State 4002, PosSet]
type = PosSet
trigger1 = Time = 0
y = 0

[State 4002, VelSet]
type = VelSet
trigger1 = Time < 90
x = 4

[State 4001, Hitdef f3]
type = HitDef
trigger1 = Animelem = 3
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-45
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4001, Hitdef f6]
type = HitDef
trigger1 = Animelem = 6
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-45
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4001, Hitdef f10]
type = HitDef
trigger1 = Animelem = 10
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-45
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4001, Hitdef f14]
type = HitDef
trigger1 = Animelem = 14
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-25
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4001, Hitdef f18]
type = HitDef
trigger1 = Animelem = 18 
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-25
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4001, Hitdef f22]
type = HitDef
trigger1 = Animelem = 22
attr = A, HA
animtype  = Medium
damage    = 20, 5
priority  = 5
guardflag = MA
pausetime = 1,1
sparkxy = 10,-35
getpower = 0
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.slidetime = 8
ground.hittime  = 8
p2stateno = 4010
kill = 0

[State 4002, Changestate]
type = ChangeState
trigger1 = Time >= 90
value = 3000

;---------------------------------------------------------------------------
; HUZZAH! (getting beat down)
[Statedef 4010]
type    = S
movetype= H
physics = S
velset = 0,0
anim = 5002

[State 4010, PosSet]
type = PosSet
trigger1 = Time = 0
y = 0

[State 4010, Changestate]
type = ChangeState
trigger1 = Time >= 300
value = 0
