;===========================================================================
; Koopa Troopa's Kart Hyper
;----------------------------------------
;Vars used:
; 0 - Determines if the Koopa PANCH has been comboed into.
; 1 - Holds time during multi-hit version of Shell Spin
; 3 - random velocity, horizontal, on coins in SKS
; 4 - random velocity, vertical, on coins in SKS
; 5 - Shun Koopa Satsu finish
; 6 - random winpose selector
; 7 - checks if KT has slid into shell
; 58 - used in a helper state to store if a coin has hit or not.
; 59 - used in a helper state to store random horiz vel without
;       changing it every tick, as my old code did.
;===========================================================================
;---------------------------------------------------------------------------
; Kart Super!
[Statedef 3400]
type    = S
physics = S
anim = 3400
velset = 0,0
ctrl = 0

[State 3400, Helper]
type = Helper
trigger1 = Time = 1
helpertype = normal
name = "Kart"
ID = 3410
pos = 0,-260
postype = p1
facing = 1
stateno = 3410
ownpal = 1
supermovetime = 38
size.xscale = 1
size.yscale = 1

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 1 
value = 4, 4
channel = 0

[State 3400, SuperPause]
type = SuperPause
trigger1 = Time = 1
sound = 20, 0
pos = -17,-27
poweradd = -1000
time = 38
movetime = 38

[State 3400, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 3402

;---------------------------------------------------------------------------
; Kart Super (Riding Kart)
[Statedef 3402]
type    = S
movetype= A
physics = S
velset = 0,0
anim = 3402

[State 3001, PlaySnd]
type = PlaySnd
trigger1 = Time = 1 
value = 16, 1

[State 3402, DRIVE THAT BITCH]
type = Veladd
trigger1 = Time > 0
x = 2 - (P2Dist X < 0)

[State 3402, CRASH AND BURN]
type = HitDef
trigger1 = Time > 6
trigger2 = Time > 3 && FrontEdgeBodyDist < 20 ;to prevent whiffing cornered foes
attr = S, HA
hitflag = MA
guardflag = MA
;affectteam = E
animtype = Hard
priority = 6,Hit
damage = 315,31
pausetime = 0,14
sparkno = 3
sparkxy = -12,-9
hitsound = s13, 1
guardsound = s14, 2
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -8, -6
guard.velocity = -4
air.velocity = -8,-5
fall = 1
air.fall = 1
fall.recover = 0
getpower = 0
p1stateno = 3403 ;Spinning away
; stolen from Sander! :D
Palfx.time = 60         
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 3402, Changestate] ;In case of guarding, miss, or error
type = Changestate
trigger1 = Movecontact
trigger2 = FrontEdgeBodyDist < 5
value = 3403

;---------------------------------------------------------------------------
; Kart Super (Flying Away)
[Statedef 3403]
type    = A
movetype= I
physics = N
velset = -4,-8
anim = 3403

[State 3403, Gravity]
type = Gravity
trigger1 = 1

[State 3403, Changestate] ;Hit ground
type = Changestate
trigger1 = Vel Y > 0
trigger1 = Pos Y >= 0
value = 5100

;---------------------------------------------------------------------------
; The Kart (falling from sky)
[Statedef 3410]
type    = A
movetype= I
physics = N
;velset = 0,0
anim = 3410

[State 3410, AngleAdd]
type = AngleAdd
trigger1 = Time % 5
value = -25

[State 3410, Gravity]
type = Veladd
trigger1 = 1
y = .50

[State 3410, AngleDraw]
type = AngleDraw
trigger1 = 1

[State 3410, ChangeState]
type = ChangeState
trigger1 = Vel Y > 0 && Pos Y >= 0
value = 3411

;---------------------------------------------------------------------------
; The Kart (on ground)
[Statedef 3411]
type    = S
physics = S
anim = 3411
velset = 0,0

[State 3411, PosSet]
type = PosSet
trigger1 = Time = 0
y = 0

[State 3411, Make Invisible]
type = ChangeAnim
trigger1 = parent, Stateno = 3402
value = 9999

[State 3411, Bind to KT]
type = BindToParent
trigger1 = parent, Stateno = 3402
time = 1
facing = 1
pos = 0,0

[State 3410, ChangeState]
type = ChangeState
;trigger1 = parent, Stateno = 3403
trigger1 = parent, Stateno != 3402 && parent, Stateno != 3400
value = 3412

;---------------------------------------------------------------------------
; The Kart (flying away)
[Statedef 3412]
type    = A
movetype= I
physics = N
velset = -4,-8
anim = 3410

[State 3412, EnvShake]
type = EnvShake
trigger1 = Time = 1
time = 25
freq = 85
ampl = -8

[State 3412, PlaySnd]
type = PlaySnd
trigger1 = Time = 1
value = 16, 0

[State 3412, KA-BLOOIE!]
type = Explod
trigger1 = Time = 1
anim = 3405
ID = 3405
pos = 21,-30
postype = p1
facing = 1
bindtime = 1
vel = 0,0
removetime = -2
scale = 1, 1
ontop = 1
ownpal = 1
removeongethit = 0

[State 3410, AngleAdd]
type = AngleAdd
trigger1 = Time % 5
value = -25

[State 3410, AngleDraw]
type = AngleDraw
trigger1 = 1

[State 3410, DestroySelf]
type = DestroySelf
trigger1 = Time = 90
