;===========================================================================
; Koopa Troopa's Specials
;----------------------------------------
;Vars used:
; 0 - Determines if the Koopa PANCH has been comboed into.
; 1 - Holds time during multi-hit version of Shell Spin
; 3 - random velocity, horizontal, on coins in SKS
; 4 - random velocity, vertical, on coins in SKS
; 5 - Shun Koopa Satsu finish
; 6 - random winpose selector
; 7 - checks if KT has slid into shell
; 58 - used in a helper state to store if a coin has hit or not.
; 59 - used in a helper state to store random horiz vel without
;       changing it every tick, as my old code did.
;===========================================================================
;---------------------------------------------------------------------------
; Light Flash Kick
;  Blatently Stolen From KFM.
[Statedef 1000]
type    = S
movetype= A
physics = S
juggle  = 8
poweradd= 110
velset = 0,0
anim = 1000
ctrl = 0
sprpriority = 2

[State 1000, Startup Invincibility]
type = NotHitBy
trigger1 = Time = 0
value = SCA
time = 6

[State 1000, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
animtype  = Medium
damage    = 45, 3
priority  = 5
guardflag = MA
pausetime = 2,9
sparkxy = -10,-70
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 18
ground.hittime  = 18
ground.velocity = -2.5,-7
guard.velocity = -7
air.velocity = -3.5,-7
air.recover = 0
fall = 1

[State 1000, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 1001

;------------------
; Light Flash Kick - Jump
;  Also Blatently Stolen From KFM.
[Statedef 1001]
type    = A
movetype= A
physics = A
velset = 2,-5.5
anim = 1001

[State 1001, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1001, Hitdef]
type = HitDef
trigger1 = AnimElem = 2
attr = A, SA
animtype  = Medium
damage    = 85, 3
priority  = 5
guardflag = MA
pausetime = 2,9
sparkxy = -10,-50
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 18
ground.hittime  = 18
ground.velocity = -2.5,-7
guard.velocity = -7
air.velocity = -3.5,-7
air.recover = 0
fall = 1

[State 1001, Explod]
type = Explod
trigger1 = Animelem = 2 
anim = 1005 
ID = 1005
pos = 0,0
postype = p1
facing = 1
bindtime = 6
removetime = -2
ontop = 1
ownpal = 1
removeongethit = 1

[State 1001, Veladd]
type = VelAdd
trigger1 = Vel X > 1
x = -.45

;[State 1001, CtrlSet]
;type = CtrlSet
;trigger1 = Animtime > 20
;value = 1

;---------------------------------------------------------------------------
; Medium Flash Kick
[Statedef 1010]
type    = S
movetype= A
physics = S
juggle  = 9
poweradd= 110
velset = 0,0
anim = 1000
ctrl = 0
sprpriority = 2

[State 1010, Startup Invincibility]
type = NotHitBy
trigger1 = Time = 0
value = SCA
time = 6

[State 1010, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
animtype  = Medium
damage    = 55, 4
priority  = 5
guardflag = MA
pausetime = 2,7
sparkxy = -10,-70
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 20
ground.hittime  = 20
ground.velocity = -3,-7.2
guard.velocity = -7
air.velocity = -4,-7.2
air.recover = 0
fall = 1

[State 1010, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 1011

;------------------
; Medium Flash Kick - Jump
[Statedef 1011]
type    = A
movetype= A
physics = A ;N
velset = 3,-7.5
anim = 1001

[State 1011, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1011, Hitdef]
type = HitDef
trigger1 = Animelem = 2
attr = A, SA
animtype  = Medium
damage    = 90, 9
priority  = 5
guardflag = MA
pausetime = 2,7
sparkxy = -10,-50
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 20
ground.hittime  = 20
ground.velocity = -3,-7.2
guard.velocity = -7
air.velocity = -4,-7.2
air.recover = 0
fall = 1

[State 1011, Explod]
type = Explod
trigger1 = Animelem = 2 
anim = 1005 
ID = 1015
pos = 0,0
postype = p1
facing = 1
bindtime = 9
removetime = -2
ontop = 1
ownpal = 1
removeongethit = 1

[State 1011, Veladd]
type = VelAdd
trigger1 = Vel X > 1
x = -.45

;[State 1011, CtrlSet]
;type = CtrlSet
;trigger1 = Animtime > 20
;value = 1

;---------------------------------------------------------------------------
; Hard Flash Kick
[Statedef 1020]
type    = S
movetype= A
physics = S
juggle  = 10
poweradd= 130
velset = 0,0
anim = 1000
ctrl = 0
sprpriority = 2

[State 1020, Startup Invincibility]
type = NotHitBy
trigger1 = Time = 0
value = SCA
time = 6

[State 1020, Hitdef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
animtype  = Medium
damage    = 65, 5
priority  = 5
guardflag = MA
pausetime = 2,6
sparkxy = -10,-70
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 22
ground.hittime  = 22
ground.velocity = -4,-7.4
guard.velocity = -7
air.velocity = -3.5,-7.4
air.recover = 0
fall = 1

[State 1010, ChangeState]
type = ChangeState
trigger1 = AnimTime = 0
value = 1021

;------------------
; Hard Flash Kick - Jump
[Statedef 1021]
type    = A
movetype= A
physics = A ;N
velset = 3.5,-9
anim = 1001

[State 1021, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1021, Hitdef 2]
type = HitDef
trigger1 = Animelem = 2
attr = A, SA
animtype  = Medium
damage    = 105, 10
priority  = 5
guardflag = MA
pausetime = 2,8
sparkxy = -10,-50
hitsound = s13, 1
guardsound = s14, 2
ground.type = Low
ground.slidetime = 22
ground.hittime  = 22
ground.velocity = -4.5,-9
guard.velocity = -7
air.velocity = -4,-7.4
air.recover = 0
fall = 1

[State 1021, Explod]
type = Explod
trigger1 = Animelem = 2 
anim = 1005 
ID = 1025
pos = 0,0
postype = p1
facing = 1
bindtime = 9
removetime = -2
ontop = 1
ownpal = 1
removeongethit = 1

[State 1021, Veladd]
type = VelAdd
trigger1 = Vel X > 1
x = -.45

[State 1021, CtrlSet]
type = CtrlSet
trigger1 = Animtime > 20
value = 1

;---------------------------------------------------------------------------
; Light Koopa Spin
[Statedef 1100]
type    = S
movetype= A
physics = S
poweradd= 100
anim = 1100
velset = 0,0
ctrl = 0

[State 1100, PalFXWiz A]
type = PalFX 
trigger1 = (Time > 45 && Time < 120) && Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1100, PalFXWiz B]
type = PalFX
trigger1 = Time > 120 && Time % 2
time = 1
add = 255,255,255

[State 1100, Changestate A]
type = Changestate
trigger1 = command != "hold_x" && (Time > 4 && Time < 46)
value = 1101

[State 1100, Changestate B]
type = Changestate
trigger1 = command != "hold_x" && (Time > 45 && Time < 119)
value = 1102

[State 1100, Changestate C]
type = Changestate
trigger1 = command != "hold_x" && Time > 120
trigger2 = Time > 240 ; Hold it too long, and it will just go.
value = 1104

;----------------------
; No-Charge Light Spin
[Statedef 1101]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1101, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1101, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 120,12
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1101, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 5
y = 0

[State 1101, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1101, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1101, Other Changestate]
type = Changestate
trigger1 = Time > 27
value = 11
ctrl = 1

;----------------------
; Mild Charge Light Spin
[Statedef 1102]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1102, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1102, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1102, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 75,9
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6
guard.velocity = -5
air.velocity = -3,-6

[State 1102, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 5
y = 0

[State 1102, Varset]
type = VarSet
trigger1 = Movecontact
v = 1
value = (Time)

[State 1102, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1103

[State 1102, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1102, Other Changestate]
type = Changestate
trigger1 = Time > 27
value = 11
ctrl = 1

;----------------------
; Mild Charge Light Spin Hit Two
[Statedef 1103]
type    = S
movetype= A
physics = S

[State 1103, VarAdd]
type = VarAdd
trigger1 = 1
v = 1
value = 1

[State 1103, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1103, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 75,9
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1103, Velset]
type = Velset
trigger1 = var(1) < 25
x = 5
y = 0

[State 1103, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1103, MakeDust, BITCH!]
type = MakeDust
trigger1 = var(1) < 25
pos = 0,0
spacing = 4

[State 1103, Other Changestate]
type = Changestate
trigger1 = var(1) > 27
value = 11
ctrl = 1

;----------------------
; Max Charge Light Spin
[Statedef 1104]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1104, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1104, PalFXWiz B]
type = PalFX
trigger1 = Time % 2
time = 1
add = 255,255,255

[State 1104, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = ;MA
animtype = Medium
priority = 4,Hit
damage = 120,12
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1104, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 5
y = 0

[State 1104, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1104, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1104, Other Changestate]
type = Changestate
trigger1 = Time > 27
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Medium Koopa Spin
[Statedef 1110]
type    = S
movetype= A
physics = S
juggle  = 5
poweradd= 100
anim = 1100
velset = 0,0
ctrl = 0

[State 1110, PalFXWiz A]
type = PalFX 
trigger1 = (Time > 45 && Time < 120) && Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1110, PalFXWiz B]
type = PalFX
trigger1 = Time > 120 && Time % 2
time = 1
add = 255,255,255

[State 1110, Changestate]
type = Changestate
trigger1 = command != "hold_y" && (Time > 4 && Time < 46)
value = 1111

[State 1110, Changestate]
type = Changestate
trigger1 = command != "hold_y" && (Time > 45 && Time < 119)
value = 1112

[State 1110, Changestate]
type = Changestate
trigger1 = command != "hold_y" && Time > 120
trigger2 = Time > 240 ; Hold it too long, and it will just go.
value = 1114

;----------------------
; No-Charge Medium Spin
[Statedef 1111]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1111, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1111, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 100,10
pausetime = 9,11
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 15
ground.slidetime = 14
ground.velocity = -4, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1111, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 6
y = 0

[State 1111, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1111, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1111, Other Changestate]
type = Changestate
trigger1 = Time > 29
value = 11
ctrl = 1

;----------------------
; Mild Charge Medium Spin
[Statedef 1112]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1112, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1112, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1112, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 65,7
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6

[State 1112, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 6
y = 0

[State 1112, Varset]
type = VarSet
trigger1 = Movecontact
v = 1
value = (Time)

[State 1112, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1113

[State 1112, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1112, Other Changestate]
type = Changestate
trigger1 = Time > 29
value = 11
ctrl = 1

;----------------------
; Mild Charge Light Spin Hit Two
[Statedef 1113]
type    = S
movetype= A
physics = S

[State 1113, VarAdd]
type = VarAdd
trigger1 = 1
v = 1
value = 1

[State 1113, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1113, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 65,7
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1113, Velset]
type = Velset
trigger1 = var(1) < 25
x = 6
y = 0

[State 1113, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1113, MakeDust, BITCH!]
type = MakeDust
trigger1 = var(1) < 25
pos = 0,0
spacing = 4

[State 1113, Other Changestate]
type = Changestate
trigger1 = var(1) > 29
value = 11
ctrl = 1

;----------------------
; Max Charge Medium Spin
[Statedef 1114]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1114, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1114, PalFXWiz B]
type = PalFX
trigger1 = Time % 2
time = 1
add = 255,255,255

[State 1114, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = ;MA
animtype = Medium
priority = 4,Hit
damage = 100,10
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1114, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 6
y = 0

[State 1114, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1114, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1114, Other Changestate]
type = Changestate
trigger1 = Time > 29
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Strong Koopa Spin
[Statedef 1120]
type    = S
movetype= A
physics = S
juggle  = 5
poweradd= 100
anim = 1100
velset = 0,0
ctrl = 0

[State 1120, PalFXWiz A]
type = PalFX 
trigger1 = (Time > 45 && Time < 120) && Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1120, PalFXWiz B]
type = PalFX
trigger1 = Time > 120 && Time % 2
time = 1
add = 255,255,255

[State 1120, Changestate]
type = Changestate
trigger1 = command != "hold_z" && (Time > 4 && Time < 46)
value = 1121

[State 1120, Changestate]
type = Changestate
trigger1 = command != "hold_z" && (Time > 45 && Time < 119)
value = 1122

[State 1120, Changestate]
type = Changestate
trigger1 = command != "hold_z" && Time > 120
trigger2 = Time > 240 ; Hold it too long, and it will just go.
value = 1124

;----------------------
; No-Charge Strong Spin
[Statedef 1121]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1121, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1121, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 80,8
pausetime = 9,9
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 13
ground.slidetime = 12
ground.velocity = -4, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1121, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 7.5
y = 0

[State 1121, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1121, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1121, Other Changestate]
type = Changestate
trigger1 = Time > 31
value = 11
ctrl = 1

;----------------------
; Mild Charge Strong Spin
[Statedef 1122]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1122, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1122, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1122, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 55,6
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6

[State 1122, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 7.5
y = 0

[State 1122, Varset]
type = VarSet
trigger1 = Movecontact
v = 1
value = (Time)

[State 1122, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1123

[State 1122, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1122, Other Changestate]
type = Changestate
trigger1 = Time > 31
value = 11
ctrl = 1

;----------------------
; Mild Charge Strong Spin Hit Two
[Statedef 1123]
type    = S
movetype= A
physics = S

[State 1123, VarAdd]
type = VarAdd
trigger1 = 1
v = 1
value = 1

[State 1123, PalFXWiz A]
type = PalFX 
trigger1 = Time % 2
time = 1
add = 164,-40,-51
mul = 256,256,256
color = 256

[State 1123, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 55,6
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1123, Velset]
type = Velset
trigger1 = var(1) < 25
x = 7.5
y = 0

[State 1123, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1123, MakeDust, BITCH!]
type = MakeDust
trigger1 = var(1) < 25
pos = 0,0
spacing = 4

[State 1123, Other Changestate]
type = Changestate
trigger1 = var(1) > 31
value = 11
ctrl = 1

;----------------------
; Max Charge Strong Spin
[Statedef 1124]
type    = S
movetype= A
physics = S
juggle  = 5
anim = 1101
velset = 0,0
ctrl = 0

[State 1124, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 4
channel = 0

[State 1124, PalFXWiz B]
type = PalFX
trigger1 = Time % 2
time = 1
add = 255,255,255

[State 1124, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = ;MA
animtype = Medium
priority = 4,Hit
damage = 80,8
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 15,-10
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -5
guard.velocity = -5
air.velocity = -3,-6
fall = 1
air.fall = 1

[State 1124, Velset]
type = Velset
trigger1 = Time >= 7 && Movecontact = 0 && Time < 25
x = 7.5
y = 0

[State 1124, Changestate]
type = Changestate
trigger1 = Movecontact
value = 1150

[State 1124, MakeDust, BITCH!]
type = MakeDust
trigger1 = Time < 25
pos = 0,0
spacing = 4

[State 1124, Other Changestate]
type = Changestate
trigger1 = Time > 31
value = 11
ctrl = 1

;---------------------------------------------------------------------------
; Koopa Spin End
[Statedef 1150]
type    = A
physics = A
anim = 1101
ctrl = 0
velset = -2, -8

[State 1150, Null]
type = Null
trigger1 = 1

;---------------------------------------------------------------------------
; Light Koopa PANCH (Startup)
[Statedef 1200]
type    = S
physics = S
anim = 1200
velset = 0,0
ctrl = 0

[State 1200, Varset A]
type = VarSet
trigger1 = Time = 0
v = 0
value = 0

[State 1200, Varset B] ; if comboed into...
type = VarSet
trigger1 = prevstateno = 200 || prevstateno = 210 || prevstateno = 220 ; There fucking _has_
trigger2 = prevstateno = 230 || prevstateno = 240 || prevstateno = 250 ; to be a better way
trigger3 = prevstateno = 400 || prevstateno = 410 || prevstateno = 420 ; to do this. But
trigger4 = prevstateno = 430 || prevstateno = 440 || prevstateno = 450 ; [200,250] doesn't work.
v = 0
value = 1

[State 1200, Changestate]
type = Changestate
trigger1 = Time > 15 - (var(0) * 10)
value = 1201

;---------------------------------------------------------------------------
; Light Koopa PANCH (Punching)
[Statedef 1201]
type    = S
movetype= A
physics = S
juggle  = 5
poweradd= 100
anim = 1201

[State 1201, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 2
channel = 0

[State 1201, PlaySnd]
type = PlaySnd
trigger1 = Animelem = 2 
value = 16, 0

[State 1201, Kaboom!]
type = Explod
trigger1 = Animelem = 2
anim = 1205
ID = 1205 
pos = 28,-36
postype = p1
facing = 1
bindtime = -1
vel = 0,0
removetime = -2
scale = 0.7, 0.7
ontop = 1
ownpal = 1
removeongethit = 0

[State 1201, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 105 - (var(0) * 30),9
pausetime = 10,13
;sparkno = 
;guard.sparkno = 
;sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -4, -4
guard.velocity = -1
air.velocity = -3,-4
; stolen from Sander! :D
Palfx.time = 30          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 

[State 1201, Tackle Followup]
type = ChangeState
trigger1 = (command = "holdfwd" && command = "punch") && Movecontact
value = 1203

[State 1201, VelSet]
type = Velset
trigger1 = Animelem = 2
x = 8

[State 1201, Changestate]
type = Changestate
trigger1 = Time > 29
value = 1202

;---------------------------------------------------------------------------
; Light Koopa PANCH (Tackle)
[Statedef 1203]
type    = S
movetype= A
physics = S
juggle  = 3
poweradd= 100
anim = 1203

[State 1213, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 1
channel = 0

[State 1203, VelSet]
type = Velset
trigger1 = Animelem = 3
x = 10

[State 1203, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 50 - (var(0) * 15),6
pausetime = 7,10
sparkno = 2
;guard.sparkno = 
sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -5, -2
guard.velocity = -1
air.velocity = -3,-2
; stolen from Sander! :D
Palfx.time = 30          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 1203, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 1202

;---------------------------------------------------------------------------
; Light Koopa PANCH (Recovery)
[Statedef 1202]
type    = S
movetype= A
physics = S
anim = 1202

[State 1202, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Medium Koopa PANCH (Startup)
[Statedef 1210]
type    = S
physics = S
anim = 1200
velset = 0,0
ctrl = 0

[State 1210, Varset A]
type = VarSet
trigger1 = Time = 0
v = 0
value = 0

[State 1210, Varset B] ; if comboed into...
type = VarSet
trigger1 = prevstateno = 200 || prevstateno = 210 || prevstateno = 220 ; There fucking _has_
trigger2 = prevstateno = 230 || prevstateno = 240 || prevstateno = 250 ; to be a better way
trigger3 = prevstateno = 400 || prevstateno = 410 || prevstateno = 420 ; to do this. But
trigger4 = prevstateno = 430 || prevstateno = 440 || prevstateno = 450 ; [200,250] doesn't work.
v = 0
value = 1

[State 1210, Changestate]
type = Changestate
trigger1 = Time > 20 - (var(0) * 10)
value = 1211

;---------------------------------------------------------------------------
; Medium Koopa PANCH (Punching)
[Statedef 1211]
type    = S
movetype= A
physics = S
juggle  = 5
poweradd= 100
anim = 1201

[State 1211, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 2
channel = 0

[State 1201, PlaySnd]
type = PlaySnd
trigger1 = Animelem = 2 
value = 16, 0

[State 1211, Kaboom!]
type = Explod
trigger1 = Animelem = 2
anim = 1205
ID = 1205 
pos = 28,-36
postype = p1
facing = 1
bindtime = -1
vel = 0,0
removetime = -2
scale = 1, 1
ontop = 1
ownpal = 1
removeongethit = 0

[State 1211, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 125 - (var(0) * 30),9
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -4, -4
guard.velocity = -1
air.velocity = -3,-4
fall = 1
air.fall = 1
; stolen from Sander! :D
Palfx.time = 40          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 

[State 1211, Tackle Followup]
type = ChangeState
trigger1 = (command = "holdfwd" && command = "punch") && Movecontact
value = 1213

[State 1211, VelSet]
type = Velset
trigger1 = Animelem = 2
x = 10

[State 1211, Changestate]
type = Changestate
trigger1 = Time > 34
value = 1212

;---------------------------------------------------------------------------
; Medium Koopa PANCH (Tackle)
[Statedef 1213]
type    = S
movetype= A
physics = S
juggle  = 3
poweradd= 100
anim = 1203

[State 1213, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 1
channel = 0

[State 1213, VelSet]
type = Velset
trigger1 = Animelem = 3
x = 12

[State 1213, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 50 - (var(0) * 15),6
pausetime = 7,10
sparkno = 2
;guard.sparkno = 
sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -5, -2
guard.velocity = -1
air.velocity = -3,-2
; stolen from Sander! :D
Palfx.time = 30          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 1213, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 1212

;---------------------------------------------------------------------------
; Medium Koopa PANCH (Recovery)
[Statedef 1212]
type    = S
movetype= A
physics = S
anim = 1202

[State 1212, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1

;---------------------------------------------------------------------------
; Heavy Koopa PANCH (Startup)
[Statedef 1220]
type    = S
physics = S
anim = 1200
velset = 0,0
ctrl = 0

[State 1220, Varset A]
type = VarSet
trigger1 = Time = 0
v = 0
value = 0

[State 1220, Varset B] ; if comboed into...
type = VarSet
trigger1 = prevstateno = 200 || prevstateno = 210 || prevstateno = 220 ; There fucking _has_
trigger2 = prevstateno = 230 || prevstateno = 240 || prevstateno = 250 ; to be a better way
trigger3 = prevstateno = 400 || prevstateno = 410 || prevstateno = 420 ; to do this. But
trigger4 = prevstateno = 430 || prevstateno = 440 || prevstateno = 450 ; [200,250] doesn't work.
v = 0
value = 1

[State 1220, Changestate]
type = Changestate
trigger1 = Time > 25 - (var(0) * 10)
value = 1221

;---------------------------------------------------------------------------
; Heavy Koopa PANCH (Punching)
[Statedef 1221]
type    = S
movetype= A
physics = S
juggle  = 5
poweradd= 100
anim = 1201

[State 1221, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 2
channel = 0

[State 1201, PlaySnd]
type = PlaySnd
trigger1 = Animelem = 2 
value = 16, 0

[State 1221, Kaboom!]
type = Explod
trigger1 = Animelem = 2
anim = 1205
ID = 1205 
pos = 28,-36
postype = p1
facing = 1
bindtime = -1
vel = 0,0
removetime = -2
scale = 1.3, 1.3
ontop = 1
ownpal = 1
removeongethit = 0

[State 1221, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Diagup
priority = 4,Hit
damage = 145 - (var(0) * 30),9
pausetime = 10,13
;sparkno = 1
;guard.sparkno = 
sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -6, -4
guard.velocity = -4
air.velocity = -5,-4
fall = 1
air.fall = 1
fall.recover = 0
; stolen from Sander! :D
Palfx.time = 50          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1   

[State 1221, Tackle Followup]
type = ChangeState
trigger1 = (command = "holdfwd" && command = "punch") && Movecontact
value = 1223

[State 1221, VelSet]
type = Velset
trigger1 = Animelem = 2
x = 13

[State 1221, Changestate]
type = Changestate
trigger1 = Time > 34
value = 1222

;---------------------------------------------------------------------------
; Strong Koopa PANCH (Tackle)
[Statedef 1223]
type    = S
movetype= A
physics = S
juggle  = 3
poweradd= 100
anim = 1203

[State 1223, PlaySnd]
type = PlaySnd
trigger1 = Time = 2 
value = 3, 1
channel = 0

[State 1223, VelSet]
type = Velset
trigger1 = Animelem = 3
x = 12

[State 1223, HitDef]
type = HitDef
trigger1 = Time = 0
attr = A, SA
hitflag = MAF
guardflag = MA
animtype = Medium
priority = 4,Hit
damage = 45 - (var(0) * 15),6
pausetime = 7,10
sparkno = 2
;guard.sparkno = 
sparkxy = 3,-25
hitsound = s13, 1
guardsound = s14, 2
ground.type = High
ground.hittime = 17
ground.slidetime = 15
ground.velocity = -5, -2
guard.velocity = -1
air.velocity = -3,-2
; stolen from Sander! :D
Palfx.time = 30          
Palfx.add = 40,-70,-200                               
Palfx.sinadd = 40,30,0,10                                
Palfx.color = 0                                              
Palfx.invertall = 1 
fall = 1

[State 1223, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 1222

;---------------------------------------------------------------------------
; Heavy Koopa PANCH (Recovery)
[Statedef 1222]
type    = S
movetype= A
physics = S
anim = 1202

[State 1222, Changestate]
type = Changestate
trigger1 = Animtime = 0
value = 0
ctrl = 1
